#line 1 ".\Src\main.c"
#line 1 "C:\Sonix\SN8_C_~1.264\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\main.c"
#line 1 ".\Include\fc2523.h"

#line 5 ".\Include\fc2523.h"




struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;
















sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;
sfr	RBANK = 0x87;

 sfr     TM0M    =0X90;
 sfr    TM0CL   =0X91;
 sfr    TM0CH   =0X92;
 sfr    TM0D0L  =0X93;
 sfr    TM0D0H  =0X94;
 sfr    TM0D1L  =0X95;
 sfr    TM0D1H  =0X96;
 sfr    PWM0E   =0X97;

 sfr	SPIC0	=0X98;
 sfr	SPIC1	=0X99;
 sfr	SPIBUF	=0X9A;

 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    lcdadr  =  0x9f;
 sfr    lcddb   =  0x9e;
 sfr    lcdseg  =  0x9d;
 sfr    lcdcom  =  0x9c;
 sfr    lcdcon  =  0x9b;

 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0Xbe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P2M=0XC2;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P2W = 0Xdd;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;
sbit    TM1IF=0xc8:3;
sbit    TM1IE=0xc9:3;
sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAB:2;
sbit	E2P_PG		=0xAB:1;
sbit	E2P_RD		=0xAB:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;


sbit	TKM0S0		=0x88:0;
sbit	TKM0S1		=0x88:1;
sbit	TKTMPS0		=0x88:2;
sbit	TKTMPS1		=0x88:3;
sbit	TKM0EN		=0x88:4;
sbit	TKM1EN		=0x88:5;
sbit	TKTMSC		=0x88:6;
sbit	TKEN		=0x88:7;

sbit	TKM1S0		=0x89:0;
sbit	TKM1S1		=0x89:1;
sbit	TKRDS0		=0x89:2;
sbit	TKTCEN		=0x89:3;
sbit	TKTCFS0		=0x89:4;
sbit	TKTCFS1		=0x89:5;
sbit	TKTCFS2		=0x89:6;
sbit	TKTMREN		=0x89:7;









sbit	LCDEN		=0x9B:0;
sbit	RESL0		=0x9B:1;
sbit	RESL1		=0x9B:2;
sbit	OSCS		=0x9B:3;
sbit	LCDT0		=0x9B:4;
sbit	LCDT1		=0x9B:5;
sbit	LCDRC_EN	=0x9B:6;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	FEOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	FADENB		=0xB9:7;



sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;



sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;


sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;



sbit	FPWM0OE		=0x90:0;
sbit	FALOAD0		=0x90:1;
sbit	FT0CKS0		=0x90:2;
sbit	FT0CKS1		=0x90:3;
sbit	FT0PS0		=0x90:4;
sbit	FT0PS1		=0x90:5;
sbit	FT0PS2		=0x90:6;
sbit	FTM0ENB		=0x90:7;

sbit	FPWM1OE		=0xA0:0;
sbit	FALOAD1		=0xA0:1;
sbit	FT1CKS0		=0xA0:2;
sbit	FT1CKS1		=0xA0:3;
sbit	FT1PS0		=0xA0:4;
sbit	FT1PS1		=0xA0:5;
sbit	FT1PS2		=0xA0:6;
sbit	T1TR		=0xA0:7;

sbit	FPWM2OE		=0xB0:0;
sbit	FALOAD2		=0xB0:1;
sbit	FT2CKS0		=0xB0:2;
sbit	FT2CKS1		=0xB0:3;
sbit	FT2PS0		=0xB0:4;
sbit	FT2PS1		=0xB0:5;
sbit	FT2PS2		=0xB0:6;
sbit	FTM2ENB		=0xB0:7;


sbit	PWM01E		=0x97:0;
sbit	PWM00HL		=0x97:1;
sbit	PWM01HL		=0x97:2;
sbit	PWM0M		=0x97:3;
sbit	PWM00OE		=0x97:4;
sbit	PWM01OE		=0x97:5;
sbit	TC0WAKE		=0x97:6;
sbit	PWM0OD		=0x97:7;

sbit	PWM11E		=0xA7:0;
sbit	PWM10HL		=0xA7:1;
sbit	PWM11HL		=0xA7:2;
sbit	PWM1M		=0xA7:3;
sbit	PWM10OE		=0xA7:4;
sbit	PWM11OE		=0xA7:5;
sbit	TC1WAKE		=0xA7:6;
sbit	PWM1OD		=0xA7:7;

sbit	PWM21E		=0xB7:0;
sbit	PWM20HL		=0xB7:1;
sbit	PWM21HL		=0xB7:2;
sbit	PWM2M		=0xB7:3;
sbit	PWM20OE		=0xB7:4;
sbit	PWM21OE		=0xB7:5;
sbit	TC2WAKE		=0xB7:6;
sbit	PWM2OD		=0xB7:7;



sbit	INT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IEN		=0xc9:2;
sbit	FTM1IEN		=0xc9:3;
sbit	FTM2IEN		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	I2CIE		=0xc9:6;
sbit	ADCIE		=0xc9:7;

sbit	E2PIE		=0xc7:0;
sbit	TKTMRIE		=0xc7:1;
sbit	SPIIE		=0xc7:2;
sbit	T0IE	    =0xC7:3;
sbit	OPAIE    	=0xC7:4;

sbit	INT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IRQ		=0xc8:2;
sbit	FTM1IRQ		=0xc8:3;
sbit	FTM2IRQ		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	I2CIF		=0xc8:6;
sbit	ADCIF		=0xc8:7;

sbit	E2PIF		=0xc6:0;
sbit	TKTMRIF		=0xc6:1;
sbit	SPIIF		=0xc6:2;
sbit	T0IF	    =0xC6:3;
sbit	OPAIF    	=0xC6:4;

sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;

sbit	FP25 = 0xd2:5;
sbit	FP24 = 0xd2:4;
sbit	FP23 = 0xd2:3;
sbit	FP22 = 0xd2:2;
sbit	FP21 = 0xd2:1;
sbit	FP20 = 0xd2:0;

sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;

sbit	FP17M = 0xc1:7;
sbit	FP16M = 0xc1:6;
sbit	FP15M= 0xc1:5;
sbit	FP14M = 0xc1:4;
sbit	FP13M = 0xc1:3;
sbit	FP12M = 0xc1:2;
sbit	FP11M = 0xc1:1;
sbit	FP10M = 0xc1:0;

sbit	FP17UR = 0xe1:7;
sbit	FP16UR = 0xe1:6;
sbit	FP15UR= 0xe1:5;
sbit	FP14UR = 0xe1:4;
sbit	FP13UR = 0xe1:3;
sbit	FP12UR = 0xe1:2;
sbit	FP11UR = 0xe1:1;
sbit	FP10UR = 0xe1:0;


sbit	FP37M = 0xc3:7;
sbit	FP36M = 0xc3:6;
sbit	FP35M= 0xc3:5;
sbit	FP34M = 0xc3:4;
sbit	FP33M = 0xc3:3;
sbit	FP32M = 0xc3:2;
sbit	FP31M = 0xc3:1;
sbit	FP30M = 0xc3:0;



sbit	FCLKMD = 0xca:2;
sbit	FSTPHX = 0xca:1;



sbit	FGIE = 0xdf:7;















#line 2 ".\Src\main.c"
#line 1 ".\Include\E2PROM.H"




void E2promInit(void);
void e2prom_write(unsigned int e2_adders,unsigned int e2_data);
unsigned int e2prom_read(unsigned int e2_adders);

void  e2_c();
void  e2_s(unsigned int e2_adders);
void  e2_byte(unsigned int e2_adders);


#line 3 ".\Src\main.c"
















#line 26 ".\Src\main.c"
unsigned int bit_h;



bit rf_end_flag=1;
bit d=1;
unsigned int p;
unsigned int speed=8;
unsigned int speed_mode=0;
unsigned int read_mode=0;
unsigned int LED_flag=0;
unsigned int clock_start=1;
unsigned int xxx=0;
unsigned int HX_count;
unsigned int rf_get_mode=0;
unsigned int rf_high_time,rf_low_time;
unsigned int rf_data[4];
unsigned int rf_count;
unsigned int count=0;
unsigned long  key_count=0;
unsigned int t=0;
unsigned int t2=0;
unsigned int t3=0;
unsigned int t4=0;
unsigned int t5=0;
unsigned int t6=0;
unsigned int next=0;
unsigned int mode=0;
unsigned int  mode1[5]={0x00,0x01,0x03,0x07,0x0f};
unsigned int  mode2[5]={0x00,0x08,0x0c,0x0e,0x0f};
unsigned int  mode3[8]={0x0f,0x0d,0x0b,0x07,0x07,0x0b,0x0d,0x0e};
unsigned int  mode4[2]={0x0f,0x00};
unsigned int  mode5[2]={0x05,0x0a};
unsigned int  mode7_1[4]={0x01,0x02,0x04,0x08};
unsigned int  mode7_2[29]={0x01,0x00,0x03,0x00,0x07,0x00,0x0f,0x00,0x0e,0x00,0x0c,0x00,0x08,0x00,0x00,0x08,0x00,0x0c,0x00,0x0e,0x00,0x0f,0x00,0x07,0x00,0x03,0x00,0x01,0x00};
unsigned int  mode7_3[2]={0x0f,0x00};
unsigned int  mode8_1[4]={0x08,0x04,0x02,0x01};
unsigned int  mode8_2[12]={0x00,0x00,0x06,0x06,0x0f,0x0f,0x00,0x00,0x06,0x06,0x0f,0x0f};
unsigned int  mode8_3[4]={0x01,0x02,0x04,0x08};
unsigned int mode9[9]={0x00,0x08,0x04,0x02,0x01,0x01,0x02,0x04,0x08};
unsigned int mode10[7]={0x00,0x0c,0x06,0x03,0x03,0x06,0x0c};
unsigned int mode11[2]={0x03,0x0c};
unsigned int mode12[5]={0x0a,0x05,0x00,0x05,0x0a};
unsigned int mode13[3]={0x00,0x06,0x0f};
unsigned int mode14[3]={0x00,0x09,0x0f};
unsigned int mode15[20]={0x03,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x03,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00,0x0c,0x00};
unsigned int mode15_2[8]={0x0f,0x0f,0x00,0x00,0x00,0x00,0x00,0x00};
unsigned int mode15_3[15]={0x0f,0x00,0x0f,0x00,0x0f,0x00,0x0f,0x00,0x0f,0x00,0x00,0x00,0x00,0x00,0x00};
	void PX(unsigned int f)
       {

 FP31 =f&0x01; f>>=1;
 FP30 =f&0x01; f>>=1;
 FP14 =f&0x01; f>>=1;
 FP15 =f&0x01; f>>=1;
 FP16 =f&0x01; f>>=1;
 FP35 =f&0x01;
       }
	   void chose()
	   {
           switch(mode)
		{
		   case 0:  PX(mode1[t]);break;
		   case 1:  PX(mode2[t]);break;
           case 2:  PX(mode3[t]);break;
		   case 3:  PX(mode4[t]);break;
		   case 4:  PX(mode5[t]);break;
           case 5:  PX(0x3f);break;
		   case 6:  if(next==0 || next==1)
		            {PX(mode7_1[t]);}
					if(next==2 || next==3)
		            {PX(mode7_2[t2]);}
					if(next>=4)
		            {PX(mode7_3[t3]);}
					break;

           case 7:  PX(mode9[t]);break;
		   case 8:  PX(mode10[t]);break;
		   case 9:  PX(mode11[t]);break;
		   case 10:  PX(mode12[t]);break;
		   case 11:  PX(mode13[t]);break;
		   case 12:  PX(mode14[t]);break;

           case 13:  if(next==0 || next==1)
		            {PX(mode8_1[t]);}

					if(next==2 || next==3)
		            {PX(mode7_2[t2]);}

					if(next==4)
		            {PX(mode8_2[t3]);}

					if(next>=5 && next<=16)
					{PX(mode7_3[t4]);}

					if(next==17 || next==18)
		            {PX(mode8_3[t5]);}
					if(next>=19)
		            {PX(mode7_3[t6]);}

					break;
		   case 14:	if(next<=3)
		            {PX(mode15[t]);}
					if(next>3&&next<=7)
		            {PX(mode15_2[t2]);}
					if(next>7&&next<=11)
		            {PX(mode15_3[t3]);}
					break;

           case 18:


 FP31 =0;
 FP30 =0;
 FP14 =0;
 FP15 =0;
 FP16 =0;
 FP35 =0;
					break;

		}
	   }
void key_control()
{
	if(FP32 ==0)
	{
		key_count++;
		if(key_count== 480)
        {
			d=1;
			mode=18;
			e2_s(0x00);
			e2prom_write(0x06,read_mode);
            e2prom_write(0x09,mode);
			e2prom_write(0x07,d);
            e2prom_write(0x08,speed_mode);
		    e2prom_write(0x00,0);
         }
		if(key_count> 480)
		{
		    key_count= 480 +1;
		}
	}
	else
	{
		if(key_count> 10 &&key_count< 480)
		{
		   if(d==0)
		   {
			   mode++;
		   }
		   if(d==1)
		   {
			   d=0;
			   mode=read_mode;
		   }
		   read_mode=mode;
		   count=0;
		   p=0;
		   t=0;
		   t2=0;
		   t3=0;
		   t4=0;
		   t5=0;
		   t6=0;
		   next=0;
		   e2_s(0x00);
				        e2prom_write(0x06,read_mode);
                        e2prom_write(0x09,mode);
						e2prom_write(0x07,d);
                        e2prom_write(0x08,speed_mode);
						e2prom_write(0x00,0);
		   if(mode>14&&mode!=18)
		   {
			   mode=0;
		   }
		}
		key_count=0;
	}
}
void delay(unsigned long i)
{
	while(i--);
}
void T0Init(void)
{
	T0M=0x80;
	T0C=22;
	T0IE=1;
	T0IF=0;
	FGIE=1;
}

void Tm1Init()
{

	TM1C=56;
	TM1M=0xe3;

	FTM1IRQ=0;
	T1TR=1;

	FTM1IEN=1;
	FGIE=1;
}


void main()
{
    P3M=0xf3;
    P1M=0xff;
    P3UR=0x0c;
    P1UR=0x00;
    P1=0x00;
    P3=0x00;
    T0Init();
    Tm1Init();
	if(e2prom_read(0x00)!=0)
	{
	   e2_s(0x00);
	   e2prom_write(0x06,0);
       e2prom_write(0x09,0);
	   e2prom_write(0x07,0);
       e2prom_write(0x08,0);
	   e2prom_write(0x00,0);
	}
	read_mode=e2prom_read(0x06);
	speed_mode=e2prom_read(0x08);
	mode=e2prom_read(0x09);
	d=e2prom_read(0x07);
	while(1)
	{
		WDTR=0X5au;
		delay(300);
		if(count>8)
		{
		   count=0;
		}
		key_control();
		if(rf_end_flag==1)
{
                    if(LED_flag==1)
                    {

						if(bit_h==0x0c&&d==0)
						{
						   mode++;
						   if(mode>14&&mode!=18)
						   {
						      mode=0;
						   }
						   count=0;
						   p=0;
						   t=0;
						   t2=0;
						   t3=0;
						   t4=0;
		   t5=0;
		   t6=0;
						   next=0;
                           read_mode=mode;

						}
						if(bit_h==0x30&&d==0)
						{
						   mode=5;
						   read_mode=mode;
						}
						if(bit_h==0xc0&&d==0)
						{
						   speed_mode++;
						   count=0;
						   p=0;
						}
						if(bit_h==0x03)
						{

						   d=~d;
						   if(d==1)
						   {

						      mode=18;
						   }
						   if(d==0)
						   {

						      mode=read_mode;
						   }

						}
						e2_s(0x00);
				         e2prom_write(0x06,read_mode);
                        e2prom_write(0x09,mode);
						e2prom_write(0x07,d);
                        e2prom_write(0x08,speed_mode);
						e2prom_write(0x00,0);
						rf_end_flag=0;

						bit_h=0;
					    LED_flag=0;
                      }
}
            switch(speed_mode)
		    {
			case 0: if(mode==14)
			        {
					   speed=2;
			        }
					else
					{
					   speed=8;
					}
					break;
			case 1: if(mode==14)
			        {
					   speed=2;
			        }
					else
					{
					   speed=4;
					}
					break;
			case 2: if(mode==14)
			        {
					   speed=1;
			        }
					else
					{
					   speed=2;
					}
			        break;
			case 3: if(mode==14)
			        {
					   speed=1;
			        }
					else
					{
					   speed=1;
					}
	                break;
	        default :speed_mode=0;
	        }
			if(mode==14)
			{
			    if(speed_mode==0)
				{
					if(p>=2)
					{
						 p=0;
						chose();

				    }
			     }
				 else if(speed_mode==1)
				 {
				    if(p>=2)
					{
						 p=0;
						chose();

				    }
				 }
				else
				{
				   	chose();
				}
			}
			else
			{
				if(speed_mode==0)
				{
					if(p>=8)
					{
						 p=0;
						chose();

				    }
			     }
				else
				{
				   	chose();
				}
		        if(mode==18 || mode==5)
				{
				  chose();
				}
			}
	}
}

void __interrupt[0x08] interrupt_isr(void)
{
	if(T0IF==1)
	{
		T0C=22;
		T0IF=0;


		if(clock_start==1)
	   {
	      xxx++;
	   }

		if(mode==0 || mode==1)
		{
		    count++;
			p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>4)
			{
			   t=0;
			}
		}
	    if(mode==2)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>7)
			{
			   t=0;
			}
		}
		if(mode==3)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>1)
			{
			   t=0;
			}
		}
		if(mode==4)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>1)
			{
			   t=0;
			}
		}
		if(mode==6)
		{
		   count++;
		   p++;
			if(count==speed)
			{
				if(next==0 ||next==1)
				{
				   t++;
				}
				if(next==2 || next==3)
				{
				   t2++;
				}
				if(next>=4)
				{
				   t3++;
				}
			    count=0;
			}

				if(t>3)
				{
				   t=0;
				   next++;
				}
				if(t2>28)
				{
				   t2=0;
				   next++;
				}
				if(t3>1)
				{
				   t3=0;
				   next++;
				   if(next>19)
				   {
				      next=0;
				   }
				}
		}
		if(mode==7)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>8)
			{
			   t=0;
			}
		}
		if(mode==8)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>6)
			{
			   t=0;
			}
		}
		if(mode==9)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>1)
			{
			   t=0;
			}
		}
		if(mode==10)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>4)
			{
			   t=0;
			}
		}
		if(mode==11)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>2)
			{
			   t=0;
			}
		}
		if(mode==12)
		{
		   count++;
		   p++;
			if(count==speed)
			{
			   t++;
			   count=0;
			}
			if(t>2)
			{
			   t=0;
			}
		}

		if(mode==13)
		{
		   count++;
		   p++;
			if(count==speed)
			{
				if(next==0 || next==1)
				{
				   t++;
				}

				if(next==2 || next==3)
				{
				   t2++;
				}

				if(next==4)
				{
				   t3++;
				}

                if(next>=5&&next<=16)
				{
				   t4++;
				}

				if(next==17 || next==18)
				{
				   t5++;
				}
				if(next>=19)
				{
				   t6++;
				}

			    count=0;
			}

				if(t>3)
				{
				   t=0;
				   next++;
				}


				if(t2>28)
				{
				   t2=0;
				   next++;
				}


				if(t3>11)
				{
				   t3=0;
				   next++;
				}


				if(t4>1)
				{
				   t4=0;
				   next++;
				}

				if(t5>3)
				{
				   t5=0;
				   next++;
				}
				if(t6>1)
				{
				   t6=0;
				   next++;
				   if(next>30)
				   {
				      next=0;
				   }
				}
		}
		if(mode==14)
		   {
		   count++;
		   p++;
			if(count==speed)
			{
				if(next<=3)
				{
				   t++;
				}
				if(next>3&&next<=7)
				{
				   t2++;
				}
				if(next>7&&next<=11)
				{
				   t3++;
				}
			    count=0;
			}

				if(t>19)
				{
				   t=0;
				   next++;
				}
				if(t2>6)
				{
				   t2=0;
				   next++;
				}
				if(t3>14)
				{
				   t3=0;
				   next++;
				   if(next>11)
				   {
				      next=0;
				   }
				}
		}

	}
	if(FTM1IRQ)
	{
		FTM1IRQ=0;

	    if(xxx==6)
		{
		clock_start=0;

	    if(rf_get_mode==0)
		{
				rf_count=0;
				rf_data[3]=0;
				if(FP33)
				{
					if((rf_low_time> 33)&&(rf_low_time< 120))
					{
						rf_get_mode=1;

					}
					else
					{
						rf_get_mode=0;
					}
					rf_high_time=0;
					rf_low_time=0;
				}
				else
				{
					if(rf_low_time<240)
					{
						rf_low_time++;
					}
					else
					{
					   rf_end_flag=1;
					}
				}
		}
		else if(rf_get_mode==1)
		{
				if(FP33)
				{
					rf_high_time++;
				}
				else
				{
					if(rf_high_time<=20)
					{
						rf_get_mode=2;

					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
						rf_end_flag=1;
					}

				}
		}
		else if(rf_get_mode==2)
		{
				if(! FP33)
				{
					rf_low_time++;
				}
				else
				{
					if(rf_low_time<=20)

					{
						rf_get_mode=3;

					}
					else
					{
						rf_high_time=0;
						rf_low_time=0;
						rf_get_mode=0;
						rf_end_flag=1;
					}

				}
		}
		else if(rf_get_mode==3)
		{
				if(rf_low_time<rf_high_time)
				{
					rf_data[3]|=0x01;
				}
				rf_count++;
				if((rf_count%8)==0)
				{

					rf_data[0]=rf_data[1];
					rf_data[1]=rf_data[2];
					rf_data[2]=rf_data[3];
					rf_data[3]=0;
				}
				if(rf_count==24)
				{
					if(0x55 ==rf_data[0])
					{
					   if(0x55 ==rf_data[1])
					   {

						    bit_h=rf_data[2];
	                        LED_flag=1;
							rf_low_time=0;
							rf_high_time=0;
							rf_get_mode=0;
							clock_start=1;
							xxx=0;
                        }
                     }

				}
				else
				{
					rf_low_time=0;
					rf_high_time=0;
					rf_get_mode=1;

				}
							rf_data[3]<<=1;
		}
}
}

}







